﻿


@model OperationalRiskException.Core.ViewModels.AssessmentSetupVM
@{
    ViewBag.Title = "Assessment Setup";
    Layout = "~/Views/Shared/_LayoutProcessor.cshtml";
}



<div class="row">
    <div class="col-md-12 grid-margin">
        <div class="d-flex justify-content-between flex-wrap">
            <div class="d-flex align-items-end flex-wrap">
                <div class="d-flex">
                    <i class="mdi mdi-home text-muted hover-cursor"></i>
                    <p class="text-muted mb-0 hover-cursor">&nbsp;/&nbsp; Configuration Management &nbsp;/&nbsp;</p>
                    <p class="text-primary mb-0 hover-cursor">Assessment Setup</p>
                </div>
            </div>

        </div>
    </div>
</div>
<div class="row">
    <div class="col-md-12 grid-margin stretch-card">
        <div class="card">
            <div class="card-body">
                <h4 class="card-title"> Assessment </h4>
                <p class="card-description">
                    Setup
                </p>

                @using (Html.BeginForm("index", "AssessmentSetup", FormMethod.Post, new { @class = "forms-sample", role = "form" }))
                {
                    @Html.AntiForgeryToken()

                    <div class="row">
                        <div class="form-group col-md-12">
                            <label for="exampleInputUsername1">Assessment Name</label>
                            <div class="row col-md-12">
                                @Html.EditorFor(n => n.AssessmentName, new { htmlAttributes = new { @class = "form-control", @placeholder = "Assessment Name" } })
                                @Html.ValidationMessageFor(model => model.AssessmentName, null, new { @class = "text text-danger" })
                            </div>
                        </div>
                        <div class="form-group col-md-6">
                            <label for="exampleInputUsername1">Start Date</label>
                            <div class="row col-md-12">
                                @Html.EditorFor(model => model.StartDate, new
                                {
                                    htmlAttributes = new
                                    {
                                        @readonly = "true",
                               Value = Model.StartDate.ToString("dd-MMM-yyyy"),
                                        @class = "date-ui datepicker",
                                          @id = "StartDate"
                                    }
                                })
                            </div>
                            <div>
                                @Html.ValidationMessageFor(model => model.StartDate, null, new { @class = "text text-danger" })
                            </div>
                        </div>


                        <div class="form-group col-md-6">
                            <label for="exampleInputUsername1">End Date</label>
                            <div class="row col-md-12">
                                @Html.EditorFor(model => model.EndDate, new
                                {
                                    htmlAttributes = new
                                    {
                                        @readonly = "true",
                               Value = Model.EndDate.ToString("dd-MMM-yyyy"),
                                        @class = "date-ui datepicker",
                                        @id = "EndDate"
                                    }
                                })
                            </div>
                            <div>
                                @Html.ValidationMessageFor(model => model.EndDate, null, new { @class = "text text-danger" })
                            </div>
                        </div>


                        <div class="form-group col-md-12">
                            <label for="exampleInputUsername1">Select Question Categories</label>
                            <div class="row col-md-12">
                                @Html.DropDownListFor(n => n.ListOfQuestionCategories, Enumerable.Empty<SelectListItem>(), "Please select Question", new { @class = "form-control select2 col-md-12", @id = "select2", @multiple = "multiple" })
                                @Html.ValidationMessageFor(model => model.ListOfQuestionCategories, null, new { @class = "text text-danger" })
                            </div>
                        </div>


                        <button type="submit" class="btn btn-primary mr-2">Create Assessment Period</button>
                    </div>
                }

            </div>
        </div>
    </div>
</div>
<div class="row">
        <div class="col-md-12 grid-margin stretch-card">
            <div class="card tablecontainer">
                <div class="card-body">
                    <h4 class="card-title"></h4>
                    <p class="card-description">
                        List of Assessments
                    </p>
                    <div class="table-responsive pt-3">
                        <table class="table table-bordered" id="myTable">
                            <thead>
                                <tr>
                                    <th>
                                        AssessmentName
                                    </th>
                                    <th>
                                        StartDate
                                    </th>
                                    <th>
                                        EndDate
                                    </th>
                                    <th>
                                        Edit
                                    </th>
                                    <th>
                                        Delete
                                    </th>

                                </tr>
                            </thead>
                            <tbody></tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
<div id="UpdatePopup" class="modal fade">
        <div class="modal-dialog">
            <div class="modal-content" id="layout">

            </div>
        </div>
    </div>

<script type="text/javascript">
    var oTable;
    var toastrChecker;
    $(document).ready(function () {
        DateTimePicker();
        dataTableLoader();
                      toastrFunction();
       
        $("#StartDate").change(function () {
            var date2 = $("#StartDate").datepicker('getDate', '+1d');
            console.log(date2);
            date2.setDate(date2.getDate() + 1);
            $("#EndDate").datepicker('option', 'minDate', date2);
            $("#EndDate").datepicker('setDate', date2);
        });
        var pageSize = 20;
        var optionListUrl = '@Url.Action("GetAllCategories", "AssessmentSetup")';
        $('#select2').select2(
            {
                ajax: {
                    delay: 150,
                    url: optionListUrl,
                    dataType: 'json',
                    data: function (params) {
                        params.page = params.page || 1;
                        return {
                            searchTerm: params.term,
                            pageSize: pageSize,
                            pageNumber: params.page
                        };
                    },
                    processResults: function (data, params) {
                        params.page = params.page || 1;
                        return {
                            results: data.Results,
                            pagination: {
                                more: (params.page * pageSize) < data.Total
                            }
                        };
                    }
                },
                placeholder: "-- Please select a name --",
                //minimumInputLength: 3,
                allowClear: true,

            });

    });
    function dataTableLoader() {
                    $("#myTable").dataTable().fnDestroy();
                     oTable = $("#myTable").DataTable({
                        "processing": true, // for show progress bar
                        "filter": true, // this is for disable filter (search box)
                         "orderMulti": false, // for disable multiple column at once
                         "serverSide": true,
                        columns: [
         
                            { 'data': 'AssessmentName' },
                            { 'data': 'StartDateString' },
                            { 'data': 'EndDateString' },

                            {
                                "data": "Id", orderable: false, "width": "50px", render: function (data) {
                                    return '<a class="btn btn-primary btn-lg pt-2 pb-2"  href="@Url.Action("Update", "AssessmentSetup")?Id=' + data + '">Edit</a>';
                                }
                            },
                                  {
                                "data": "Id", orderable: false, "width": "50px", render: function (data) {
                                  return '<a class="btn btn-danger btn-lg pt-2 pb-2"  href="@Url.Action("Delete", "AssessmentSetup")?Id=' + data + '">Delete</a>';
                                  }
                            }
                        ],

                        "delay": 150,
                        "ajax": {
                            "url": '@Url.Action("GetAll", "AssessmentSetup")', 
                            "type": "POST",
                            "datatype": "json"
                        }
                    });
                   return oTable;
                }
    function DateTimePicker() {
        $(".datepicker").datepicker({
            dateFormat: 'dd-M-yy',
            changeMonth: true,
            changeYear: true,
            showOn: 'button',
            sideBySide : true,
            controlType: 'select',
            buttonText: '<span class="mdi mdi-calendar mdi-24px" ></span>',
            minDate: new Date()
        });
    }
    function updateModal(userId) {
        $.get('@Url.Action("GetAssessmentConf", "AssessmentSetup")/', { Id: userId }, function (res) {
            $("#layout").html(res);  
            $("#UpdatePopup").modal("show");

        });
        }
    function UpdateAssessment() {
    var form = $('form[name="updateAss"]');
    var entry = form.serialize();
    $.get('@Url.Action("Edit", "AssessmentSetup")', entry, function (res) {  
    console.log("Assessment Update", res);
    if (res.data) {
    toastr.success(res.message, "Notification");
    oTable.ajax.reload();
    }
    else {
     toastr.error(res.message, "Notification");
        }
    });
    }
    function toastrFunction() {

         if ('@TempData["CreateCat"]'.length > 1) {
          toastr.success('@TempData["CreateCat"]','Notification');
         }
         else  if ('@TempData["Failed"]'.length>1) {
          toastr.error('@TempData["Failed"]','Notification');
       }

    }
</script>

